#!/usr/bin/env ruby

# Copyright (c) 2010 Microsoft Corp.
# License: ?

require 'rubygems'
require 'ruby-aws'

if ARGV.length < 3
	$stderr.puts("Usage: #{$0} <video-id> <results-file> <solutions-file>")
	exit
end

videoId        = ARGV[0]
results_file   = ARGV[1]
solutions_file = ARGV[2]
results = Amazon::Util::DataReader.load(results_file, :Tabular)

File.open(solutions_file, 'w') do |f|
	f.puts '<?xml version="1.0"?>'
	f.puts '<videos>'
	f.puts '<video id="' + videoId + '">'

	results.each do |r|
		if r[:videoId] == videoId
			f.puts '  <solution id="' + r[:AssignmentId] + '">'
			f.puts '    <coordX>' + r[:coordX] + '</coordX>'
			f.puts '    <coordY>' + r[:coordY] + '</coordY>'
			f.puts '    <timestamp>' + r[:timestamp] + '</timestamp>'
			f.puts '    <valid>' + r[:valid] + '</valid>'
			f.puts '  </solution>'
		end
	end

	f.puts '</video>'
	f.puts '</videos>'
end

