function [] = plot_delays()

%
% Warning: to generate the data for this script, run process_assignments.php without the second iteration and
% then add the reference.
% (This script already incorporates the second iteration pruning algorithm)
%

load redballjump;
fontsize = 14;

fprintf('Number of workers: %d\n', size(coordX,2));

[delay_samp, delay_time] = estimate_delay(coordX, coordY);
delay_time
fprintf('Mean delay: %.2f\n', mean(delay_time(2:end)));
%coordX = shiftcoord(coordX, -delay_samp);
%coordY = shiftcoord(coordY, -delay_samp);

[coordX, coordY] = remove_outliers(coordX, coordY);

close all
figure
hist(delay_time)
xlabel('Delay time', 'FontSize', fontsize);
ylabel('Count', 'FontSize', fontsize);
set(gca, 'FontSize', fontsize);
pbaspect([1 0.2 1]);
print -depsc jump_histogram.eps

figure
hold on
plot(timestamp, coordX(:,2:end))
plot(timestamp, coordX(:,1), '-k', 'LineWidth', 2)
xlabel('timestamp (s)', 'FontSize', fontsize);
ylabel('x coordinate (px)', 'FontSize', fontsize);
set(gca, 'FontSize', fontsize);
axis([30 50 100 550]);
%axis([0 max(timestamp) 0 640]);
pbaspect([1 0.2 1]);
print -depsc jump_coordX.eps

figure
hold on
plot(timestamp, coordY(:,2:end))
plot(timestamp, coordY(:,1), '-k', 'LineWidth', 2)
xlabel('timestamp (s)', 'FontSize', fontsize);
ylabel('y coordinate (px)', 'FontSize', fontsize);
set(gca, 'FontSize', fontsize);
%axis([30 50 0 360]);
axis([0 max(timestamp) 0 360]);
pbaspect([1 0.2 1]);
print -depsc jump_coordY.eps

coordX = shiftcoord(coordX, -delay_samp);
coordY = shiftcoord(coordY, -delay_samp);

figure
hold on
plot(timestamp, coordX(:,1), '-k', 'LineWidth', 3)
plot(timestamp, nanmean(coordX(:,2:end),2), '-r', 'LineWidth', 2)
xlabel('timestamp (s)', 'FontSize', fontsize);
ylabel('x coordinate (px)', 'FontSize', fontsize);
set(gca, 'FontSize', fontsize);
%axis([40 80 0 640]);
axis([0 max(timestamp) 0 640]);
pbaspect([1 0.2 1]);
print -depsc jump_coordX_mean.eps

figure
hold on
plot(timestamp, coordY(:,1), '-k', 'LineWidth', 3)
plot(timestamp, nanmean(coordY(:,2:end),2), '-r', 'LineWidth', 2)
xlabel('timestamp (s)', 'FontSize', fontsize);
ylabel('y coordinate (px)', 'FontSize', fontsize);
set(gca, 'FontSize', fontsize);
%axis([40 80 0 360]);
axis([0 max(timestamp) 0 360]);
pbaspect([1 0.2 1]);
print -depsc jump_coordY_mean.eps

for i = 2:size(coordX,2)
	coordX(:,i) = coordX(:,i) - coordX(:,1);
	coordY(:,i) = coordY(:,i) - coordY(:,1);
end

coordX = coordX(:,2:end);
coordY = coordY(:,2:end);

fprintf('X mean std dev: %.2f\n', mean(nanstd(coordX)));
fprintf('Y mean std dev: %.2f\n', mean(nanstd(coordY)));

return

nanstd(coordX)
nanstd(coordY)

figure
hist(nanstd(coordX))
xlabel('\sigma_x', 'FontSize', fontsize);
ylabel('Count', 'FontSize', fontsize);
set(gca, 'FontSize', fontsize);
pbaspect([1 0.2 1]);
print -depsc jump_sigmax_histogram.eps

figure
hist(nanstd(coordY))
xlabel('\sigma_y', 'FontSize', fontsize);
ylabel('Count', 'FontSize', fontsize);
set(gca, 'FontSize', fontsize);
pbaspect([1 0.2 1]);
print -depsc jump_sigmay_histogram.eps

%%%%

function [coordX, coordY] = remove_outliers(coordX, coordY)
for t = 1:size(coordX,1)
	for i = 2:size(coordX,2)
		count_total = 0;
		count_valid = 0;

		for j = 2:size(coordX,2)
			if i == j
				continue;
			end

			for u = t-5:t+5
				if u >= 1 && u <= size(coordX,1)
					deltaX = abs(coordX(t,i) - coordX(u,j));
					deltaY = abs(coordY(t,i) - coordY(u,j));

					if ~isnan(deltaX) && ~isnan(deltaY)
						count_total = count_total + 1;
						if deltaX < 40 && deltaY < 30
							count_valid = count_valid + 1;
						end
					end
				end
			end
		end

		if count_total > 0 && count_valid == 0
			for u = t-100:t+100
				if u >= 1 && u <= size(coordX,1)
					coordX(u,i) = NaN;
					coordY(u,i) = NaN;
				end
			end
		end
	end
end

