function [] = plot_iceage()
load iceage3;
fontsize = 14;

fprintf('Number of workers: %d\n', size(coordX,2));

L = size(coordX,1);
W = size(coordX,2);
T = max(timestamp);

imageX = zeros([640 L 3]);
imageY = zeros([360 L 3]);

color = 1 - [0 0 1];

for i = 1:L
	for j = 1:W
		mu = coordX(i,j);
		if mu > 0
			bell = normpdf((1:640)', mu, 5);
			for c = 1:3
				imageX(:,i,c) = imageX(:,i,c) + color(c)*bell;
			end
		end

		mu = coordY(i,j);
		if mu > 0
			bell = normpdf((1:360)', mu, 5);
			for c = 1:3
				imageY(:,i,c) = imageY(:,i,c) + color(c)*bell;
			end
		end
	end

	lineX = imageX(:,i,:);
	lineY = imageY(:,i,:);
	imageX(:,i,:) = imageX(:,i,:) / max(lineX(:));
	imageY(:,i,:) = imageY(:,i,:) / max(lineY(:));
end

imageX = 1 - imageX;
imageY = 1 - imageY;
ticks  = sort([0:50:T 84]);

% X history
imageX = uint8(255 * imageX);

close all
h = image(imageX);
xlabel('timestamp (s)', 'FontSize', fontsize);
ylabel('x coordinate (px)', 'FontSize', fontsize);
set(gca, 'FontSize', fontsize);

ax = get(h,'Parent');
set(h, 'Parent', ax);
set(ax,'XTick', ticks/T*L);
set(ax,'XTickLabel', ticks);
pbaspect([1 0.25 1]);
print -depsc 10x.eps

% Y history
imageY = uint8(255 * imageY);

close all
h = image(imageY);
xlabel('timestamp (s)', 'FontSize', fontsize);
ylabel('y coordinate (px)', 'FontSize', fontsize);
set(gca, 'FontSize', fontsize);

ax = get(h,'Parent');
set(h, 'Parent', ax);
set(ax,'XTick', ticks/T*L);
set(ax,'XTickLabel', ticks);
pbaspect([1 0.25 1]);
print -depsc 10y.eps


