#!/usr/bin/env ruby

require 'include/Solution'

if ARGV.length < 2
	puts "Usage: #{$0} videoId <source xml>"
else
	videoId = ARGV[0]
	src_xml = ARGV[1]

	solution_list = Solution::get_all(src_xml, videoId)
	solution_list.each do |solution|
		print "assignmentId: " + solution.assignmentId + "\n"

		print "coordX: " + solution.coordX.slice(0,10).map { |v| sprintf("%3d", v) }.join(', ')
		print ", ...\n"

		print "coordY: " + solution.coordY.slice(0,10).map { |v| sprintf("%3d", v) }.join(', ')
		print ", ...\n"

		print "timestamp: " + solution.timestamp.slice(0,10).map { |v| sprintf("%.2f", v) }.join(', ')
		print ", ...\n"

		print "minT, maxT: #{solution.timestamp.min}, #{solution.timestamp.max}\n"

		lengthX = solution.coordX.length
		lengthY = solution.coordY.length
		lengthT = solution.timestamp.length
		print "lengthX, lengthY, lengthT: (#{lengthX}, #{lengthY}, #{lengthT})\n"

		print "valid: " + solution.valid.to_s + "\n"

		print "\n"
	end
end

