#!/usr/bin/env ruby

require 'include/Solution'

if ARGV.length < 2
	puts "Usage: #{$0} videoId <source xml>"
else
	videoId = ARGV[0]
	src_xml = ARGV[1]

	solution_list = Solution::get_all(src_xml, videoId)
	max_len = solution_list.map { |solution| solution.timestamp.length }.max

	puts "clear all;"
	puts "coordX = zeros([#{ max_len } #{ solution_list.length }]);"
	puts "coordY = zeros([#{ max_len } #{ solution_list.length }]);"

	timestamp = solution_list[0].timestamp
	puts "timestamp = [" + timestamp.map { |v| sprintf("%.2f", v) }.join(',') + "]';"

	max_len.times do |t|
		coordX = []
		coordY = []

		solution_list.each do |solution|
			coordX << sprintf("%d", solution.coordX[t])
			coordY << sprintf("%d", solution.coordY[t])
		end

		puts "coordX(#{t+1},:) = [" + coordX.join(',') + "]';"
		puts "coordY(#{t+1},:) = [" + coordY.join(',') + "]';"
	end
end

